Last Comment Bug 774509 - We need to communicate the FF17 OS X 10.5 EOL to our users (add-on hotfix)
: We need to communicate the FF17 OS X 10.5 EOL to our users (add-on hotfix)
Status: VERIFIED FIXED
: verified-production
Product: Firefox
Classification: Client Software
Component: General (show other bugs)
: unspecified
: All All
: -- normal (vote)
: ---
Assigned To: Matthew N. [:MattN]
: juan becerra [:juanb]
Mentors:
Depends on: 772682 793226
Blocks: 790821 792284
  Show dependency treegraph
 
Reported: 2012-07-16 16:06 PDT by Alex Keybl [:akeybl]
Modified: 2012-10-25 15:27 PDT (History)
17 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---
+
fixed
+
fixed


Attachments
v.1 Based on hg copy of v20120430.01 (12.21 KB, patch)
2012-08-17 14:21 PDT, Matthew N. [:MattN]
dolske: review+
Details | Diff | Splinter Review
dialog after installing hotfix from bug 792284 (30.26 KB, image/png)
2012-09-19 16:54 PDT, juan becerra [:juanb]
no flags Details
Urgent billboard for 10.5 users (116.75 KB, image/png)
2012-10-03 11:02 PDT, juan becerra [:juanb]
no flags Details
billboad on production (101.10 KB, image/png)
2012-10-03 14:52 PDT, juan becerra [:juanb]
no flags Details

Description Alex Keybl [:akeybl] 2012-07-16 16:06:16 PDT
Assigning to me for now, to find somebody to create the necessary hotfix. Also including Laura here so that she's aware that we'll need to communicate the upcoming EOL (copy, sites, translations, etc.).

Basically we should target doing this as soon as possible, knowing that as of 11/17 10.5 users will no longer receive security/stability updates. Bug 741004 has an example of how we used an add-on hotfix to accomplish this previously.
Comment 1 Alex Keybl [:akeybl] 2012-07-16 16:07:01 PDT
Tracking for 16/17 given the overlapping timeframe.
Comment 2 Florian Bender 2012-07-19 02:42:14 PDT
Please add "OS X" before "10.5" in the description so it is (and will be in the future) clear what is meant by "10.5", no matter how clear it is now.
Comment 3 Alex Keybl [:akeybl] 2012-07-31 15:29:01 PDT
Current thinking:

1) Let's use https://www.mozilla.org/firefox/unsupported/mac for the billboard URL
2) Only target Mac
3) Let's make sure that the functionality in bug 741004 still works on Windows
4) Earliest we'd push this out would be end of August, latest would likely be end of September

Upon 17's release, the billboard at https://www.mozilla.org/firefox/unsupported/mac would change to read that updates will no longer be received (from a warning).
Comment 4 Alex Keybl [:akeybl] 2012-07-31 15:34:08 PDT
Matt, if you have the time I think you may be in the best position to do this over the next month. Let me know if that doesn't work for you, or if you've got questions about the changes that need to be made. I think this is mostly a simplification of bug 741004 (as long as they can be hosted separately on AMO).
Comment 5 Matthew N. [:MattN] 2012-07-31 15:40:58 PDT
(In reply to Alex Keybl [:akeybl] from comment #4)
> I think this is mostly a simplification of bug 741004 (as long as they can be hosted
> separately on AMO).

Since they have to use the same addon ID (firefox-hotfix@mozilla.org), they would have to use the same AMO listing[1] but should be able to be a separate version targeting different platforms and application versions. At least I believe AMO supports this but I could be wrong.

[1] https://addons.mozilla.org/firefox/addon/firefox-hotfix/

Code for bug 741004 is v20120430.01 at https://hg.mozilla.org/users/dtownsend_mozilla.com/hotfixes/
Comment 6 Alex Keybl [:akeybl] 2012-08-01 09:58:12 PDT
(In reply to Matthew N. [:MattN] from comment #5)
> Since they have to use the same addon ID (firefox-hotfix@mozilla.org), they
> would have to use the same AMO listing[1] but should be able to be a
> separate version targeting different platforms and application versions. At
> least I believe AMO supports this but I could be wrong.

Including Jorge to see if this is the case.
Comment 7 Jorge Villalobos [:jorgev] 2012-08-01 10:20:10 PDT
Yes, you should be able to upload a new version that only supports Mac OS X.
Comment 8 Matthew N. [:MattN] 2012-08-17 12:45:18 PDT
I'm going to start on this now.
Comment 9 Matthew N. [:MattN] 2012-08-17 14:21:29 PDT
Created attachment 652919 [details] [diff] [review]
v.1 Based on hg copy of v20120430.01

Note that this is using a hg copy from https://hg.mozilla.org/users/dtownsend_mozilla.com/hotfixes/file/tip/v20120430.01 so you this is only the changes from the Windows hotfix (bug 741004).

I haven't tested on an actual 10.5 machine since I don't have access to one.

Since the billboard is not live yet, the dialog will show an error.
Comment 10 Matthew N. [:MattN] 2012-08-26 19:36:53 PDT
dolske: review ping? It's the end of August now so we should have this ready to go out soon (per comment 3).
Comment 11 Justin Dolske [:Dolske] 2012-09-18 16:06:41 PDT
Comment on attachment 652919 [details] [diff] [review]
v.1 Based on hg copy of v20120430.01

Review of attachment 652919 [details] [diff] [review]:
-----------------------------------------------------------------

::: v20120430.01/bootstrap.js
@@ +114,5 @@
> +function isUnsupportedMacOS() {
> +  let darwinVersion = parseFloat(Services.sysinfo.getProperty("version"));
> +  if (darwinVersion >= 9.0 && darwinVersion < 10.0) {
> +    // OS X 10.5
> +    return true;

Hmmm, using floats is a bit hacky. (Especially given version numbers like 12.0.2 or 12.10).

The property looks like it's just a string underneath. Just regex parse out the major version and see if it's == 9.

::: v20120430.01/content/unsupportedOS.js
@@ +26,4 @@
>    let remoteContent = document.getElementById("updateMoreInfoContent");
>    remoteContent.update_name = "Firefox";
> +  remoteContent.update_version = "17";
> +  remoteContent.url = billboardURL;

Remind me what this is for?
Comment 12 Matthew N. [:MattN] 2012-09-18 17:18:57 PDT
(In reply to Justin Dolske [:Dolske] from comment #11)
> ::: v20120430.01/bootstrap.js
> @@ +114,5 @@
> > +function isUnsupportedMacOS() {
> > +  let darwinVersion = parseFloat(Services.sysinfo.getProperty("version"));
> > +  if (darwinVersion >= 9.0 && darwinVersion < 10.0) {
> > +    // OS X 10.5
> > +    return true;
> 
> Hmmm, using floats is a bit hacky. (Especially given version numbers like
> 12.0.2 or 12.10).
> 
> The property looks like it's just a string underneath. Just regex parse out
> the major version and see if it's == 9.

Agreed. I thought this only return the two segments.  I think I was on 12.0.0 at the time and perhaps it returned "12.0"?

Replaced with indexOf:

 function isUnsupportedMacOS() {
-  let darwinVersion = parseFloat(Services.sysinfo.getProperty("version"));
-  if (darwinVersion >= 9.0 && darwinVersion < 10.0) {
+  let darwinVersion = Services.sysinfo.getProperty("version");
+  if (darwinVersion.indexOf("9.") === 0) {
     // OS X 10.5
     return true;
   }
   return false;
 }

> ::: v20120430.01/content/unsupportedOS.js
> @@ +26,4 @@
> >    let remoteContent = document.getElementById("updateMoreInfoContent");
> >    remoteContent.update_name = "Firefox";
> > +  remoteContent.update_version = "17";
> > +  remoteContent.url = billboardURL;
> 
> Remind me what this is for?

The billboard displays loading text with the update name and version:
"Getting more details about %S %Sā€¦"
See updateMoreInfoContentDownloading in https://mxr.mozilla.org/mozilla-central/source/toolkit/locales/en-US/chrome/mozapps/update/updates.properties?rev=c20d415ef1b5#10

Pushed: https://hg.mozilla.org/users/dtownsend_mozilla.com/hotfixes/rev/b3853f35de54
Comment 13 Matthew N. [:MattN] 2012-09-19 15:25:27 PDT
Juan, you can test attachment 662543 [details] from bug 792284 when you're ready.  I'm not sure who has access to the AMO staging site to upload the hotfix there. akeybl or ashughes should know from the Win2k hotfix testing.
Comment 14 juan becerra [:juanb] 2012-09-19 16:54:53 PDT
Created attachment 662747 [details]
dialog after installing hotfix from bug 792284

That's the dialog I get when the add-on hot fix is installed on Fx16 Mac OS X 10.5.8.
Comment 15 Matthew N. [:MattN] 2012-09-19 16:57:54 PDT
(In reply to juan becerra [:juanb] from comment #14)
> Created attachment 662747 [details]
> dialog after installing hotfix from bug 792284
> 
> That's the dialog I get when the add-on hot fix is installed on Fx16 Mac OS
> X 10.5.8.

Oh, yeah, that's because the billboard (https://www.mozilla.org/firefox/unsupported/mac ) is not live yet.  Per akeybl's email, lforrest is working on getting that live this week.
Comment 16 juan becerra [:juanb] 2012-09-19 17:23:00 PDT
Also, should the hot fix in 792284 be compatible with 15.0.1 on 10.6.8? Because at the moment it isn't, so when you try to install it there's an error notification and the add-on doesn't get installed. Is this flow going to happen in the background, invisible to users in the Mac OS X 10.6 and above scenario?
Comment 17 Matthew N. [:MattN] 2012-09-19 17:40:17 PDT
(In reply to juan becerra [:juanb] from comment #16)
> Also, should the hot fix in 792284 be compatible with 15.0.1 on 10.6.8?
> Because at the moment it isn't, so when you try to install it there's an
> error notification and the add-on doesn't get installed. 

I can't find it in writing anymore but based on how the last hotfix was done the initial version should only go to the beta audience (16) then possibly expand to the release channel (15). I'm not sure if we're going to bother sending the hotfix to 15 and lower.

> Is this flow going
> to happen in the background, invisible to users in the Mac OS X 10.6 and
> above scenario?

Yes, the installation will be invisible to users and it won't get installed if the version doesn't match.  The minVersion + maxVersion is how we target hotfixes to specific Firefox versions. Testing should be done with the hotfix installed from AMO staging to see what I mean. See https://wiki.mozilla.org/QA/Desupport_Hotfix_Testing#Instructions_to_test_a_hotfix for some details from Win2k EOL.

For 10.6 and above, the hotfix will be installed but immediately uninstalled. The user won't notice this unless they happen to be looking at the extensions tab of about:addons at the time of install.
Comment 18 Alex Keybl [:akeybl] 2012-09-20 10:10:24 PDT
This hotfix will only target FF16, while the hotfix in bug 790821 will also need to target FF15 (to unbork their installs). I don't have strong feelings on whether or not we should prompt FF15 users in that bug.
Comment 19 Alex Keybl [:akeybl] 2012-09-21 11:18:33 PDT
Juan - can we manually test this hotfix, ensuring that the right URL is hit only when the user is running FF16 on Mac OS X 10.5? I would also check

* Windows/Linux/Mac10.6 on FF16 doesn't install the hotfix
* FF15 on 10.5 doesn't keep the hotfix installed
* Re-prompt is properly happening every 10 days

We can double check the web content once bug 793226 is resolved, and then push out and do one final verify with the hosted/signed XPI at that time.
Comment 20 juan becerra [:juanb] 2012-09-27 00:20:14 PDT
Testing this tomorrow prior to 16.0b5 sign-off.
Comment 21 juan becerra [:juanb] 2012-09-27 12:24:20 PDT
Testing this manually works. I've tested this across OS and only when I use Fx16 on Mac OS X 10.5 do I see a hotfix add-on in the list of extensions. The dialog also appears, although without content.

I asked jorgev to upload this to the staging server to try it more end-to-end, but it didn't work according to the instructions referenced in comment #17.

(In reply to Alex Keybl [:akeybl] from comment #19)
> Juan - can we manually test this hotfix, ensuring that the right URL is hit
> only when the user is running FF16 on Mac OS X 10.5? I would also check
> 
> * Windows/Linux/Mac10.6 on FF16 doesn't install the hotfix
> * FF15 on 10.5 doesn't keep the hotfix installed

Notice that this add-on is not compatible with Fx15 on Mac OS X (10.6 or 10.5).
Comment 22 Alex Keybl [:akeybl] 2012-09-27 12:50:32 PDT
(In reply to juan becerra [:juanb] from comment #21)
> Testing this manually works. I've tested this across OS and only when I use
> Fx16 on Mac OS X 10.5 do I see a hotfix add-on in the list of extensions.
> The dialog also appears, although without content.
> 
> I asked jorgev to upload this to the staging server to try it more
> end-to-end, but it didn't work according to the instructions referenced in
> comment #17.

What didn't work correctly? Was the add-on never downloaded?
Comment 23 juan becerra [:juanb] 2012-09-27 13:11:22 PDT
The add-on was never downloaded, even when it should have been. In the most obvious case the add-on should have been downloaded to Fx16 on 10.5 and shown the dialog. In the case of Windows XP, for example, the addon should also have been downloaded, not shown the dialog, and been uninstalled, but that didn't happen either.
Comment 24 juan becerra [:juanb] 2012-09-27 14:14:46 PDT
Matthew, jorgev uploaded the hotfix to staging (addons-dev.allizom.org) and I tested it according to the instructions in comment #17, but I never got a hotfix addon using Fx16 on 10.5.

I'm wondering if I'm missing something, like maybe I'm not editing the right config preferences correctly. Having this staged should allow us to test end-to-end.

Could you take a look and see if I am missing something?
Comment 25 Matthew N. [:MattN] 2012-09-27 14:21:15 PDT
(In reply to juan becerra [:juanb] from comment #21)
> I asked jorgev to upload this to the staging server to try it more
> end-to-end, but it didn't work according to the instructions referenced in
> comment #17.

The pref for the hotfix update check changed in Firefox 13 so I have updated the instructions. See bug 711679 comment 6. I didn't know about this change until now.

(In reply to juan becerra [:juanb] from comment #23)
> In the case of Windows XP, for example, the addon should
> also have been downloaded, not shown the dialog, and been uninstalled, but
> that didn't happen either.

This is expected.  Since the hotfix update check includes the operating system (e.g. "&appOS=WINNT"), AMO won't even offer this hotfix version to Windows since the targetPlatform is set to Darwin.

I verified that changing the new pref caused the hotfix to install in Firefox Beta (16) on 10.7.4 and no UI was shown which is correct.
Comment 26 juan becerra [:juanb] 2012-09-27 15:12:59 PDT
I've tested this with the revised instructions and now using Fx16 on Mac OS X 10.5 I get the hotfix and the prompt.

Using Fx16 on newer Mac OSs I get the addon but it disappears right away, no prompt.

Using other OSs, I get no addon.

Using Fx15 on Mac OS X 10.5 I get no addon.*

In order to see whether it had downloaded the addon I enabled the logging pref, and made sure it was updated or not.

If last one (*) is ok, then I think we are good to go. I'll remove the qawanted keyword but leave the verifyme one so we can test with the actual billboard when it is ready.
Comment 27 juan becerra [:juanb] 2012-10-03 11:02:43 PDT
Created attachment 667556 [details]
Urgent billboard for 10.5 users

Bug 793226 is in production and I was able to verify this end-to-end with the extension in staging. You can see the billboard and the link within the billboard pointing to:

http://support.mozilla.org/en-US/kb/firefox-no-longer-works-mac-os-x-10-5
Comment 28 juan becerra [:juanb] 2012-10-03 14:49:32 PDT
Comment on attachment 667556 [details]
Urgent billboard for 10.5 users

Wrong attachment.
Comment 29 juan becerra [:juanb] 2012-10-03 14:52:28 PDT
Created attachment 667664 [details]
billboad on production

Verified on production. Billboard comes up for users on Mac OS X 10.5 and link goes to the right place.
Comment 30 Matthew N. [:MattN] 2012-10-03 21:55:23 PDT
Hotfix is live for Firefox 16 users: https://addons.mozilla.org/en-US/firefox/addon/firefox-hotfix/versions/20120817.01
Comment 31 Lukas Blakk [:lsblakk] use ?needinfo 2012-10-16 15:07:43 PDT
Anything left to do here for when 17 is released or will the switch of text (from warning of de-support to announcing it) happen automatically?
Comment 32 juan becerra [:juanb] 2012-10-22 14:39:24 PDT
I've tested this again with the hotfix in bug 803596. This case is covered by that hotfix as well.

Note You need to log in before you can comment on or make changes to this bug.